#include <Servo.h>

// Chip pooper
Servo myservo_gate;
Servo myservo_push;
int pos1;
int pos2;

// Motor connections
int enableA = 9;
int input01A = 3;
int input02A = 2;
int enableB = 10;
int input01B = 4;
int input02B = 22;

//int motorspeed = 0;

// variables to store data from esp32 web server
int curLight = -1;
char theLight = ' ';

// variables for distance sensor
const int trigPin = 7;
const int echoPin = 6;
int redLightPin = 8;
long duration;
int distance;

void setup() {
  // put your setup code here, to run once:

  Serial.begin(115200);

  // motor control pins
  // motor A and motor B
  pinMode(enableA, OUTPUT);
  pinMode(input01A, OUTPUT);
  pinMode(input02A, OUTPUT);
  pinMode(enableB, OUTPUT);
  pinMode(input01B, OUTPUT);
  pinMode(input02B, OUTPUT);

  //distance sensor pins
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  pinMode(redLightPin, OUTPUT);
  digitalWrite(redLightPin, LOW);

  //Chip pooper
  //initialize servo pins
  myservo_gate.attach(11);
  myservo_push.attach(5);
  //default to 0 position
  myservo_gate.write(0);
  myservo_push.write(90);

  pinMode(12, OUTPUT); // for LED

  // Turn off all motors initial state
  digitalWrite(input01A, LOW);
  digitalWrite(input02A, LOW);
  digitalWrite(input01B, LOW);
  digitalWrite(input02B, LOW);

}

void loop() {
  // put your main code here, to run repeatedly:

  /*echoLocation();
  if (distance < 5){
    digitalWrite(redLightPin, HIGH);
    }
   else{
    digitalWrite(redLightPin, LOW);
    }*/

  if (Serial.available()> 0) { // if a keystroke is recieved from ESP32
    curLight = Serial.read(); // read the byte
  }
    //digitalWrite(12, HIGH); // turn light on to test connection
    //echoLocation();

    if (curLight == 48){ // 0
        //break;
    }
    if (curLight == 56){ // '8'  FORWARD
      if (echoLocation() > 10){
          digitalWrite(redLightPin, LOW);
          
          analogWrite(enableA, 200); //255 is max PWM speed
          analogWrite(enableB, 200);

          digitalWrite(input01A, HIGH);
          digitalWrite(input02A, LOW);
          digitalWrite(input01B, LOW);
          digitalWrite(input02B, HIGH);
          //break;
        }
      else {
          digitalWrite(redLightPin, HIGH);
          
          analogWrite(enableA, 200); //255 is max PWM speed
          analogWrite(enableB, 200);

          digitalWrite(input01A, LOW);
          digitalWrite(input02A, LOW);
          digitalWrite(input01B, LOW);
          digitalWrite(input02B, LOW);
          //break;
        }        
    }

    if (curLight == 50){ // '2'  REVERSE
        analogWrite(enableA, 155); //255 is max PWM speed
        analogWrite(enableB, 155);

        digitalWrite(input01A, LOW);
        digitalWrite(input02A, HIGH);
        digitalWrite(input01B, HIGH);
        digitalWrite(input02B, LOW);
    }
  
    if (curLight == 54){ // '6'  RIGHT
      if (echoLocation() > 10){
        digitalWrite(redLightPin, LOW);        
        analogWrite(enableA, 155); //255 is max PWM speed
        analogWrite(enableB, 155);

        digitalWrite(input01A, HIGH);
        digitalWrite(input02A, LOW);
        digitalWrite(input01B, HIGH);
        digitalWrite(input02B, LOW);
      }
      else{
        digitalWrite(redLightPin, HIGH);        
        analogWrite(enableA, 155); //255 is max PWM speed
        analogWrite(enableB, 155);

        digitalWrite(input01A, LOW);
        digitalWrite(input02A, LOW);
        digitalWrite(input01B, LOW);
        digitalWrite(input02B, LOW);        
      }
    }
  
    if (curLight == 52){ // '4'  LEFT
      if (echoLocation() > 10){
        digitalWrite(redLightPin, LOW);        
        analogWrite(enableA, 155); //255 is max PWM speed
        analogWrite(enableB, 155);

        digitalWrite(input01A, LOW);
        digitalWrite(input02A, HIGH);
        digitalWrite(input01B, LOW);
        digitalWrite(input02B, HIGH);
      }
      else {
        digitalWrite(redLightPin, HIGH);        
        analogWrite(enableA, 155); //255 is max PWM speed
        analogWrite(enableB, 155);

        digitalWrite(input01A, LOW);
        digitalWrite(input02A, LOW);
        digitalWrite(input01B, LOW);
        digitalWrite(input02B, LOW);        
      }
    }
  
    if (curLight == 57){ // '9'  FORWARD RIGHT
      if (echoLocation() > 10){
        digitalWrite(redLightPin, LOW);        
        analogWrite(enableA, 155); //255 is max PWM speed
        analogWrite(enableB, 55);

        digitalWrite(input01A, HIGH);
        digitalWrite(input02A, LOW);
        digitalWrite(input01B, LOW);
        digitalWrite(input02B, HIGH);
      }
      else {
        digitalWrite(redLightPin, HIGH);        
        analogWrite(enableA, 155); //255 is max PWM speed
        analogWrite(enableB, 55);

        digitalWrite(input01A, LOW);
        digitalWrite(input02A, LOW);
        digitalWrite(input01B, LOW);
        digitalWrite(input02B, LOW);        
      }
    }
  
    if (curLight == 55){ // '7'  FORWARD LEFT
      if (echoLocation() > 10){
        digitalWrite(redLightPin, LOW);        
        analogWrite(enableA, 55); //255 is max PWM speed
        analogWrite(enableB, 155);

        digitalWrite(input01A, LOW);
        digitalWrite(input02A, HIGH);
        digitalWrite(input01B, LOW);
        digitalWrite(input02B, HIGH);
      }
      else {
        digitalWrite(redLightPin, HIGH);        
        analogWrite(enableA, 55); //255 is max PWM speed
        analogWrite(enableB, 155);

        digitalWrite(input01A, LOW);
        digitalWrite(input02A, LOW);
        digitalWrite(input01B, LOW);
        digitalWrite(input02B, LOW);        
      }
    }
  
    if (curLight == 51){ // '3'  REVERSE RIGHT
        analogWrite(enableA, 200); //255 is max PWM speed
        analogWrite(enableB, 55);

        digitalWrite(input01A, LOW);
        digitalWrite(input02A, HIGH);
        digitalWrite(input01B, LOW);
        digitalWrite(input02B, HIGH);
    }
  
    if (curLight == 49){ // '1'  REVERSE LEFT
        analogWrite(enableA, 55); //255 is max PWM speed
        analogWrite(enableB, 200);

        digitalWrite(input01A, LOW);
        digitalWrite(input02A, HIGH);
        digitalWrite(input01B, LOW);
        digitalWrite(input02B, HIGH);
    }
  
    if (curLight == 53){ // '5'  STOPPED
        analogWrite(enableA, 0); //255 is max PWM speed
        analogWrite(enableB, 0);

        digitalWrite(input01A, LOW);
        digitalWrite(input02A, LOW);
        digitalWrite(input01B, LOW);
        digitalWrite(input02B, LOW);
    }
        
      // FOR TESTING (LED)
    if (curLight == 65){ // a
      digitalWrite(12, HIGH);
    }
    if (curLight == 66){ // b
      digitalWrite(12, LOW);
    }

    // CHIP POOPER COMMANDS
    if (curLight == 82){ // 'r'
      openGate();
      delay(100);
      pushChip();
      delay(100);
      closeGate();
      delay(2000);
    }
}    



// function to find the distance with sensor
// use int instead of void to return int value. void returns shit
int echoLocation(){ 
  // clear the trigPin
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);

  // set the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);

  // read the echoPin, return the sound wave travel time in seconds
  duration = pulseIn(echoPin, HIGH);

  // calculate the distance
  distance = duration*0.034/2;

  // print the distance on the serial monitor
  //Serial.print("distance: ");
  //Serial.println(distance);


  return distance;
}


// Functions for Chip pooper
void openGate(){
  myservo_gate.write(90);
  delay(1000);
  //myservo_gate.write(0);
}
void closeGate(){
  myservo_gate.write(0);
}
void pushChip(){
  myservo_push.write(0);
  delay(1000);
  myservo_push.write(90);
}
